Index: src/http/modules/ngx_http_image_filter_module.c
===================================================================
--- src/http/modules/ngx_http_image_filter_module.c	(revision 4598)
+++ src/http/modules/ngx_http_image_filter_module.c	(working copy)
@@ -740,7 +740,7 @@
                                    red, green, blue, t;
     u_char                        *out;
     ngx_buf_t                     *b;
-    ngx_uint_t                     resize;
+    ngx_uint_t                     resize, is_crop, calc_dx, calc_dy;
     gdImagePtr                     src, dst;
     ngx_pool_cleanup_t            *cln;
     ngx_http_image_filter_conf_t  *conf;
@@ -793,32 +793,19 @@
     dx = sx;
     dy = sy;
 
-    if (conf->filter == NGX_HTTP_IMAGE_RESIZE) {
+    if (conf->filter == NGX_HTTP_IMAGE_ROTATE) {
 
-        if ((ngx_uint_t) dx > ctx->max_width) {
-            dy = dy * ctx->max_width / dx;
-            dy = dy ? dy : 1;
-            dx = ctx->max_width;
-        }
-
-        if ((ngx_uint_t) dy > ctx->max_height) {
-            dx = dx * ctx->max_height / dy;
-            dx = dx ? dx : 1;
-            dy = ctx->max_height;
-        }
-
-        resize = 1;
-
-    } else if (conf->filter == NGX_HTTP_IMAGE_ROTATE) {
-
         resize = 0;
 
-    } else { /* NGX_HTTP_IMAGE_CROP */
+    } else { /* NGX_HTTP_IMAGE_CROP || NGX_HTTP_IMAGE_RESIZE */
 
-        resize = 0;
+        is_crop = (conf->filter == NGX_HTTP_IMAGE_CROP);
+        calc_dx = is_crop ? (ngx_uint_t) (dx * 100 / dy) <= (ctx->max_width * 100 / ctx->max_height) : 0;
+        calc_dy = (is_crop && calc_dx) ? 0 : 1;
 
-        if ((ngx_uint_t) (dx * 100 / dy)
-            < ctx->max_width * 100 / ctx->max_height)
+        resize = is_crop ? 0 : 1;
+
+        if (calc_dx)
         {
             if ((ngx_uint_t) dx > ctx->max_width) {
                 dy = dy * ctx->max_width / dx;
@@ -827,7 +814,7 @@
                 resize = 1;
             }
 
-        } else {
+        } else if (calc_dy) {
             if ((ngx_uint_t) dy > ctx->max_height) {
                 dx = dx * ctx->max_height / dy;
                 dx = dx ? dx : 1;